"""
Program ilustrující použití funkcí.
Zároveň zavádíme použití funkce main().
"""

def soucet(n = 10):
  """
    Funkce vrací součet čísel 1...n. Spočteno pomocí cyklu.
    Pokud není n zadáno, použije se defaultní hodnota.
  """
  suma = 0
  for i in range(1,n+1):
    suma = suma + i
  return suma

def soucet_jinak(n):
    """Funkce vrací součet čísel 1...n. Spočteno pomocí vzorce."""
    return(n+1)*n//2 # použito celočíselné dělení

def main():
    """
    Hlavní funkce programu.
    Umístíme sem hlavní logiku aplikace
    """
    vstup = int(input("Zadej kladné celé číslo "))
    print("Součet čísel 1 ... {0} je {1}".format(vstup, soucet(vstup)))
    print("Součet čísel 1 ... 10 je {1}".format(vstup, soucet()))
    print("Součet čísel 1 ... {0} je {1}".format(vstup, soucet_jinak(vstup)))

main()

#VARIANTA 1 Pokročilejším studentům (SŠ), můžeme ukázat použití aserce
#na vstupní hodnoty funkce. V našem případě, pro kladný vstup.
