"""
Návrh jednoduché třídy, která ukazuje základní rysy OOP:
zapouzdření
metody
vlastnosti, kontrola přístupu.
"""
class zivocich(object,): # předek je objekt
    def __init__(self,zvuk,  vaha = 10, vyska = 1.0):
        """
        Inicializační konstruktor.
        """
        self.__vaha = vaha
        self.__vyska = vyska
        self.__zvuk = zvuk

    def projev_se(self):
        """
        Zvuk (řetězec) který vydává každý živočich.
        """
        return ">>>"+self.__zvuk+"<<<"

    # definice metod pro navázání na vlastnosti
    def __get_vyska(self): # definice getter
        return self.__vyska
    def __set_vyska(self, vyska):# definice setter
        assert vyska > 0, "Nutno použít nenulovou výšku."
        self.__vyska = vyska
    vyska = property(__get_vyska, __set_vyska, "Vlastnost Vyska") #deletter neni implementovan

    # použití vzoru dekorátor pro vlastnosti
    @property #vytvoří getter
    def vaha(self):
        """Vlastnost Vaha"""
        return self.__vaha

    @vaha.setter #vytvoří setter
    def vaha(self,vaha):
        assert vaha > 0, "Nutno použít nenulovou váhu"
        self.__vaha = vaha
