"""
Ukázka dědění, člověk je speciální případem živočicha.
"""

from zivocich import *

class clovek(zivocich):
    def __init__(self,jmeno,vaha=80,vyska=185):
        """Inicializační konstruktor a volání konstruktoru předka"""
        super().__init__("ahoj", vaha,vyska)
        self.__jmeno=jmeno

    def projev_se(self):
        return super().projev_se().upper()
    def muze_snist(self, druhy):
        """
        Implementace metody člověka. Člověk může sníst
        jiného živočicha jen někdy (naivní model) a není to člověk.
        """
        assert isinstance(druhy,zivocich), "Musí být živočich."
        if self.vaha > 0.5*druhy.vaha and type(druhy) != clovek:
            return True
        return False

    @property
    def jmeno(self):
        """Vlastnost jména"""
        return self.__jmeno

    @property
    def bmi(self):
        return self.vaha/(self.vyska)**2
