"""Varianta programu na přiznání půjčky s ošetřením vstupů
 a výpisem důvodu zamítnutí.
 Studentům zatím výjimky nevysvětlujeme. Daná funkce je pro nás černou krabičkou.
 Je možné se k ní v budoucnu vrátit až budou seznámeni s mechanismem výjimek.
 Po studentech chceme pouze aplikaci jejich použití.
 Pro užití funkce zdůrazníme využití tuple.

 Možná je lehčí a kratší varianta, kde se nerozlišuje nízký a vysoký věk, ale
 pouze nepřiměřený věk, tj. věk mimo interval <18,50>.

 Můžeme též vést diskuzi se studenty o vhodnosti zadávání výdělku pouze v případě,
 že je splněna podmínka věku.

 """

def preved_int(vstup):
    try:
        hodnota = int(vstup)
        return True,hodnota
    except ValueError:
        print("Na vstupu není celé číslo.")
        return False, None


vek_vstup = input("Zadejte Váš věk ")
uspech, vek = preved_int(vek_vstup) #Zdůraznit použití tuple

if uspech:
    if vek < 18:
        print("Jste moc mladý.")
    elif vek > 50:
        print("Jste moc starý. ")
    else:
        vydelek_vstup = input("Zadejte Váš příjem ")
        uspech, vydelek = preved_int(vydelek_vstup)
        if uspech :
            if vydelek >= 30000:
                print("Půjčka přiznána.")
            else:
                print("Máte nízký příjem.")
